Index: flexpart_code/fpmetbinary_mod.F90
===================================================================
--- flexpart_code/fpmetbinary_mod.F90	(revision fd86dea2732396822196778365c05ed2ef15f881)
+++ flexpart_code/fpmetbinary_mod.F90	(revision 8624a75e20c0cc6dff42b4eb97182a138f9aa1e7)
@@ -1164,4 +1471,8 @@
 &                                vvn(0:nxmaxn-1, 0:nymaxn-1, 1:nzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","V component of wind in the Y[horizontal] &
+                                 direction for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m s**-1")
 
             ncret = nf90_def_var(ncid, 'wwn', NF90_FLOAT, &
@@ -1176,4 +1487,9 @@
 &                                wwn(0:nxmaxn-1, 0:nymaxn-1, 1:nzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","wind componend in the Z[vertical] &
+                                  direction for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m s**-1")
+
 
             ncret = nf90_def_var(ncid, 'ttn', NF90_FLOAT, &
@@ -1188,4 +1504,8 @@
 &                                ttn(0:nxmaxn-1, 0:nymaxn-1, 1:nzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","temperature for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","K")
+
 
             ncret = nf90_def_var(ncid, 'qvn', NF90_FLOAT, &
@@ -1200,4 +1520,7 @@
 &                                qvn(0:nxmaxn-1, 0:nymaxn-1, 1:nzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","specific humidity data for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
 
             ncret = nf90_def_var(ncid, 'pvn', NF90_FLOAT, &
@@ -1212,4 +1535,7 @@
 &                                pvn(0:nxmaxn-1, 0:nymaxn-1, 1:nzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","potential vorticity for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","K*m**2 kg**-1 s**-1")
 
             ncret = nf90_def_var(ncid, 'rhon', NF90_FLOAT, &
@@ -1224,4 +1550,8 @@
 &                                rhon(0:nxmaxn-1, 0:nymaxn-1, 1:nzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","air density for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","kg m**-3")
+
 
             ncret = nf90_def_var(ncid, 'drhodzn', NF90_FLOAT, &
@@ -1236,4 +1566,7 @@
 &                                drhodzn(0:nxmaxn-1, 0:nymaxn-1, 1:nzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","vertical air density gradient for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","kg m**-2")
 
 
@@ -1252,4 +1585,9 @@
 &                                tthn(0:nxmaxn-1, 0:nymaxn-1, 1:nuvzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","temperature in the original &
+                                 input model level for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","K")
+
 
             ncret = nf90_def_var(ncid, 'qvhn', NF90_FLOAT, &
@@ -1264,4 +1602,9 @@
 &                                qvhn(0:nxmaxn-1, 0:nymaxn-1, 1:nuvzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","specific humidity in the original &
+                                input model level for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ! Note the new dimensions
@@ -1279,4 +1622,11 @@
 &                                cloudsn(0:nxmaxn-1, 0:nymaxn-1, 0:nzmax, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","vcloud mask, &
+                                 no cloud no precip = 0, cloud no precip = 1, &
+                                 rainout  conv/lsp dominated  2/3, &
+                                 washout  conv/lsp dominated = 4/5 for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ! Note the new dimensions
@@ -1294,4 +1644,8 @@
 &                                cloudsnh(0:nxmaxn-1, 0:nymaxn-1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","cloud mask at the horizontal levels")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
 
@@ -1316,4 +1670,8 @@
 &                                psn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","surface pressure of the nested domian")
+            ncret = nf90_put_att(ncid, ncvarid, "units","Pa")
+
 
             ncret = nf90_def_var(ncid, 'sdn', NF90_FLOAT, &
@@ -1328,4 +1686,8 @@
 &                                sdn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","snow depth for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m")
+
 
             ncret = nf90_def_var(ncid, 'msln', NF90_FLOAT, &
@@ -1340,4 +1702,8 @@
 &                                msln(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","mean sea level pressure for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","Pa")
+
 
             ncret = nf90_def_var(ncid, 'tccn', NF90_FLOAT, &
@@ -1352,4 +1718,8 @@
 &                                tccn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","total cloud cover for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'u10n', NF90_FLOAT, &
@@ -1364,4 +1734,7 @@
 &                                u10n(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","10 m u component of wind velocity for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m s**-1")
 
             ncret = nf90_def_var(ncid, 'v10n', NF90_FLOAT, &
@@ -1376,4 +1749,7 @@
 &                                v10n(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","10 m v component of wind velocity for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m s**-1")
 
             ncret = nf90_def_var(ncid, 'tt2n', NF90_FLOAT, &
@@ -1388,4 +1764,8 @@
 &                                tt2n(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","2 m temperature for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","K")
+
 
             ncret = nf90_def_var(ncid, 'td2n', NF90_FLOAT, &
@@ -1400,4 +1780,8 @@
 &                                td2n(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","2 m dew point temperature for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","K")
+
 
             ncret = nf90_def_var(ncid, 'lsprecn', NF90_FLOAT, &
@@ -1412,4 +1796,7 @@
 &                                lsprecn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","large scale total precipitation for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","mm h**-1")
 
             ncret = nf90_def_var(ncid, 'convprecn', NF90_FLOAT, &
@@ -1424,4 +1811,7 @@
 &                                convprecn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","convective precipitation for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","mm h**-1")
 
             ncret = nf90_def_var(ncid, 'sshfn', NF90_FLOAT, &
@@ -1436,4 +1826,7 @@
 &                                sshfn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","surface sensible heat flux for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","J m**-2")
 
             ncret = nf90_def_var(ncid, 'ssrn', NF90_FLOAT, &
@@ -1448,4 +1841,7 @@
 &                                ssrn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","surface solar radiation for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","J m**-2")
 
             ncret = nf90_def_var(ncid, 'surfstrn', NF90_FLOAT, &
@@ -1460,4 +1856,8 @@
 &                                surfstrn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","surface stress for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","N m**-2 s")
+
 
             ncret = nf90_def_var(ncid, 'ustarn', NF90_FLOAT, &
@@ -1472,4 +1872,7 @@
 &                                ustarn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","friction velocity for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m s**-1")
 
             ncret = nf90_def_var(ncid, 'wstarn', NF90_FLOAT, &
@@ -1484,4 +1887,8 @@
 &                                wstarn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","convective velocity scale for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m s**-1")
+
 
             ncret = nf90_def_var(ncid, 'hmixn', NF90_FLOAT, &
@@ -1496,4 +1903,7 @@
 &                                hmixn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","mixing height for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m")
 
             ncret = nf90_def_var(ncid, 'tropopausen', NF90_FLOAT, &
@@ -1508,4 +1918,7 @@
 &                                tropopausen(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","altitude of thermal tropopause for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m")
 
             ncret = nf90_def_var(ncid, 'olin', NF90_FLOAT, &
@@ -1520,4 +1933,7 @@
 &                                olin(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","inverse Obukhov length (1/L) for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m")
 
             ncret = nf90_def_var(ncid, 'diffkn', NF90_FLOAT, &
@@ -1532,4 +1948,10 @@
 &                                diffkn(0:nxmaxn-1, 0:nymaxn-1, 1, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","diffusion coefficient at reference height &
+                                 for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m**2 s**-1")
+
+
 
             dim4dids = (/nxmaxn_dimid, nymaxn_dimid, maxspec_dimid, maxnests_dimid/)
@@ -1548,5 +1970,7 @@
 &                                vdepn(0:nxmaxn-1, 0:nymaxn-1, 1:maxspec, cm_index, 1:maxnests))
             call handle_nf90_err(ncret)
-
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","deposition velocity for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","m s**-2")
 
 !            PRINT *, 'SUM(psn): ', SUM(psn(:,:,:,cm_index,:))
@@ -1570,4 +1994,9 @@
 &                                xresoln(0:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","factor by which the resolutions in the nests &
+                                  is enhanced compared to mother grid")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'yresoln', NF90_FLOAT, &
@@ -1582,4 +2011,9 @@
 &                                yresoln(0:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","factor by which the resolutions in the nests &
+                                  is enhanced compared to mother grid")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             dim1dids = (/maxnests_dimid/)
@@ -1596,4 +2030,9 @@
 &                                xln(1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","lower left corner x  point of nested grids &
+                                in grid coordinates of mother grid")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'yln', NF90_FLOAT, &
@@ -1608,4 +2047,9 @@
 &                                yln(1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","lower left corner y  point of nested grids &
+                                in grid coordinates of mother grid")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'xrn', NF90_FLOAT, &
@@ -1620,4 +2064,9 @@
 &                                xrn(1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","upper right corner x  point of nested grids &
+                                in grid coordinates of mother grid")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'yrn', NF90_FLOAT, &
@@ -1632,4 +2081,8 @@
 &                                yrn(1:maxnests))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","upper right corner y  point of nested grids &
+                                in grid coordinates of mother grid")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
 
 !            PRINT *, 'SUM(yresoln): ', SUM(yresoln)
@@ -1649,4 +2102,8 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                southpolemap(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","auxiliary variable to define stereographic projections")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'northpolemap', NF90_FLOAT, &
@@ -1658,5 +2115,7 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                northpolemap(:))
-
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","auxiliary variable to define stereographic projections")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
 
 
@@ -1667,4 +2126,8 @@
             ncret = nf90_put_var(ncid, ncvarid, logical2integer(xglobal))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","logical variable  T for global fields, F for limited area fields")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'sglobal', NF90_INT, ncvarid)
@@ -1672,4 +2135,8 @@
             ncret = nf90_put_var(ncid, ncvarid, logical2integer(sglobal))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","logical variable  T if domain extends towards south pole")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'nglobal', NF90_INT, ncvarid)
@@ -1677,4 +2144,8 @@
             ncret = nf90_put_var(ncid, ncvarid, logical2integer(nglobal))
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","logical variable T if domain extends towards north pole")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'switchnorthg', NF90_FLOAT, ncvarid)
@@ -1682,4 +2153,8 @@
             ncret = nf90_put_var(ncid, ncvarid, switchnorthg)
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","degrees for use polar stereographic grid north of switchnorth")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'switchsouthg', NF90_FLOAT, ncvarid)
@@ -1687,4 +2162,7 @@
             ncret = nf90_put_var(ncid, ncvarid, switchsouthg)
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","degrees for use polar stereographic grid south of switchshouth")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
 
 
@@ -1707,4 +2185,8 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                pconv(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","pressure at the input model levels for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","Pa")
+
 
             ncret = nf90_def_var(ncid, 'dpr', NF90_FLOAT, &
@@ -1716,4 +2198,8 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                dpr(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","pressure difference around tconv(k)")
+            ncret = nf90_put_att(ncid, ncvarid, "units","Pa")
+
 
             ncret = nf90_def_var(ncid, 'pconv_hpa', NF90_FLOAT, &
@@ -1725,4 +2211,9 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                pconv_hpa(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","pressure at the input model levels &
+                                 in hPa for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","hPa")
+
 
             ncret = nf90_def_var(ncid, 'ft', NF90_FLOAT, &
@@ -1734,4 +2225,8 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                ft(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","auxiliary variable for the convection scheme")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'fq', NF90_FLOAT, &
@@ -1743,4 +2238,8 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                fq(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","auxiliary variable for the convection scheme")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
 
             ncret = nf90_def_var(ncid, 'sub', NF90_FLOAT, &
@@ -1753,4 +2252,9 @@
 &                                sub(:))
 
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","auxiliary variable for the convection scheme")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
+
+
             dim1dids = (/na_dimid/)
 
@@ -1763,4 +2267,8 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                phconv(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","pressure between levels k-1 and k")
+            ncret = nf90_put_att(ncid, ncvarid, "units","Pa")
+
 
             ncret = nf90_def_var(ncid, 'phconv_hpa', NF90_FLOAT, &
@@ -1772,4 +2280,7 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                phconv_hpa(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","pressure between levels k-1 and k in hPa")
+            ncret = nf90_put_att(ncid, ncvarid, "units","hPa")
 
             ncret = nf90_def_var(ncid, 'tconv', NF90_FLOAT, &
@@ -1781,4 +2292,9 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                tconv(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","temperature at the input model levels &
+                                for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","K")
+
 
             ncret = nf90_def_var(ncid, 'qconv', NF90_FLOAT, &
@@ -1790,4 +2306,9 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                qconv(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","specific humidity at the input model  &
+                                levels for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","none")
+
 
             ncret = nf90_def_var(ncid, 'qsconv', NF90_FLOAT, &
@@ -1799,4 +2320,9 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                qsconv(:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","Saturation water vapor specific humidity &
+                                for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","kg/kg")
+
 
             ! New dimensions
@@ -1811,4 +2337,8 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                fmass(:,:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","mass in the grid column for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","kg")
+
 
             ncret = nf90_def_var(ncid, 'fmassfrac', NF90_FLOAT, &
@@ -1820,4 +2350,9 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                fmassfrac(:,:))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","mass fraction due to  the convection &
+                                displacement from level k to level k")
+            ncret = nf90_put_att(ncid, ncvarid, "units","kg")
+
 
 
@@ -1833,4 +2368,7 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                cbaseflux(0:nxmax-1,0:nymax-1))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","cloudbase massflux due to the convection")
+            ncret = nf90_put_att(ncid, ncvarid, "units","(kg/m**2)/s")
 
             ! New dimensions
@@ -1845,4 +2383,7 @@
             ncret = nf90_put_var(ncid, ncvarid, &
 &                                cbasefluxn(0:nxmaxn-1,0:nymaxn-1,1:maxnests))
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","cloudbase massflux due to the convection for the nested domain")
+            ncret = nf90_put_att(ncid, ncvarid, "units","(kg/m**2)/s")
 
 
@@ -1852,4 +2393,8 @@
             ncret = nf90_put_var(ncid, ncvarid, psconv)
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","surface pressure for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","Pa")
+
 
             ncret = nf90_def_var(ncid, 'tt2conv', NF90_FLOAT, ncvarid)
@@ -1857,4 +2402,8 @@
             ncret = nf90_put_var(ncid, ncvarid, tt2conv)
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","2 m temperature for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","K")
+
 
             ncret = nf90_def_var(ncid, 'td2conv', NF90_FLOAT, ncvarid)
@@ -1862,4 +2411,8 @@
             ncret = nf90_put_var(ncid, ncvarid, td2conv)
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","2 m dew point temperature for the convection calculation")
+            ncret = nf90_put_att(ncid, ncvarid, "units","K")
+
 
             ncret = nf90_def_var(ncid, 'nconvlev', NF90_INT, ncvarid)
@@ -1867,4 +2420,7 @@
             ncret = nf90_put_var(ncid, ncvarid, nconvlev)
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","number of levels for convection")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
 
             ncret = nf90_def_var(ncid, 'nconvtop', NF90_INT, ncvarid)
@@ -1872,4 +2428,7 @@
             ncret = nf90_put_var(ncid, ncvarid, nconvtop)
             call handle_nf90_err(ncret)
+! attributes
+            ncret = nf90_put_att(ncid, ncvarid, "description","upper levels for convection")
+            ncret = nf90_put_att(ncid, ncvarid, "units"," ")
 
 !            PRINT *, 'SUM(pconv): ', SUM(pconv)
Index: flexpart_code/grib2nc4/Makefile
===================================================================
--- flexpart_code/grib2nc4/Makefile	(revision 87d96843f7f85bb599c0f7cdfb7f1f42731b9eaf)
+++ flexpart_code/grib2nc4/Makefile	(revision 8624a75e20c0cc6dff42b4eb97182a138f9aa1e7)
@@ -11,19 +11,23 @@
 NETCDFF = /opt/netcdf-fortran-4.4.3
 NETCDF = /opt/netcdf-c-4.4.0
-
+#GRIBAPI = /usr/local/grib-api
+#HDF5 = /usr/local/hdf5-1.8.16
+#NETCDFF = /usr/local/netcdf-fortran-4.4.3
+#NETCDF = /usr/local/netcdf-c-4.4.0
 
 
 
 BINARY = grib2nc4
-OBJS = processmetfields.o
-FPMODOBJS = par_mod.o com_mod.o class_vtable_mod.o cmapf_mod.o conv_mod.o 
-FLXPRTOBJS = detectformat.o grib2check.o shift_field_0.o gridcheck.o \
-	     readwind.o readwind_nests.o calcpar.o calcpar_nests.o \
-             shift_field.o pbl_profile.o scalev.o obukhov.o \
-             richardson.o ew.o getvdep.o calcpv.o obukhov_gfs.o \
-             richardson_gfs.o getvdep_nests.o calcpv_nests.o psim.o psih.o \
-             qvsat.o caldate.o getrb.o raerod.o getrc.o partdep.o \
-             verttransform.o verttransform_nests.o readwind_gfs.o \
-             calcpar_gfs.o verttransform_gfs.o gridcheck_gfs.o
+CMP_BINARY = nc4cmp
+OBJS = processmetfields.o verttransform_grib2nc4_ecmwf.o verttransform_grib2nc4_gfs.o
+FPMODOBJS = ${FLEXPART_SRC}/par_mod.o ${FLEXPART_SRC}/com_mod.o ${FLEXPART_SRC}/class_vtable_mod.o ${FLEXPART_SRC}/cmapf_mod.o ${FLEXPART_SRC}/conv_mod.o 
+FLXPRTOBJS = ${FLEXPART_SRC}/detectformat.o ${FLEXPART_SRC}/grib2check.o ${FLEXPART_SRC}/shift_field_0.o ${FLEXPART_SRC}/gridcheck.o \
+	     ${FLEXPART_SRC}/readwind.o ${FLEXPART_SRC}/readwind_nests.o ${FLEXPART_SRC}/calcpar.o ${FLEXPART_SRC}/calcpar_nests.o \
+             ${FLEXPART_SRC}/shift_field.o ${FLEXPART_SRC}/pbl_profile.o ${FLEXPART_SRC}/scalev.o ${FLEXPART_SRC}/obukhov.o \
+             ${FLEXPART_SRC}/richardson.o ${FLEXPART_SRC}/ew.o ${FLEXPART_SRC}/getvdep.o ${FLEXPART_SRC}/calcpv.o ${FLEXPART_SRC}/obukhov_gfs.o \
+             ${FLEXPART_SRC}/richardson_gfs.o ${FLEXPART_SRC}/getvdep_nests.o ${FLEXPART_SRC}/calcpv_nests.o ${FLEXPART_SRC}/psim.o ${FLEXPART_SRC}/psih.o \
+             ${FLEXPART_SRC}/qvsat.o ${FLEXPART_SRC}/caldate.o ${FLEXPART_SRC}/getrb.o ${FLEXPART_SRC}/raerod.o ${FLEXPART_SRC}/getrc.o ${FLEXPART_SRC}/partdep.o \
+             ${FLEXPART_SRC}/verttransform.o ${FLEXPART_SRC}/verttransform_nests.o ${FLEXPART_SRC}/readwind_gfs.o \
+             ${FLEXPART_SRC}/calcpar_gfs.o ${FLEXPART_SRC}/verttransform_gfs.o ${FLEXPART_SRC}/gridcheck_gfs.o
 
 
@@ -32,14 +36,14 @@
 
 INCLUDES_NETCDF = -I${NETCDFF}/include
-INCLUDES = -I${GRIBAPI}/include ${INCLUDES_NETCDF}
+INCLUDES = -I${GRIBAPI}/include ${INCLUDES_NETCDF}  -I${FLEXPART_SRC}
 
 
 ### NetCDF link flags - use the first one for dynamic libs, the second
 ### one for static libs
-#LDFLAGS_NETCDF = -L${NETCDFF}/lib -lnetcdff -L${NETCDF}/lib -lnetcdf 
-LDFLAGS_NETCDF=-static -L${NETCDFF}/lib -lnetcdff -L${NETCDF}/lib -lnetcdf -lnetcdf -L${HDF5}/lib -lhdf5_fortran -lhdf5_hl -lhdf5hl_fortran -lhdf5 -ldl -lz
+LDFLAGS_NETCDF = -L${NETCDFF}/lib -lnetcdff -L${NETCDF}/lib -lnetcdf 
+#LDFLAGS_NETCDF=-static -L${NETCDFF}/lib -lnetcdff -L${NETCDF}/lib -lnetcdf -lnetcdf -L${HDF5}/lib -lhdf5_fortran -lhdf5_hl -lhdf5hl_fortran -lhdf5 -ldl -lz
 
 
-LDFLAGS = -L${GRIBAPI}/lib -lgrib_api_f90 -lgrib_api ${LDFLAGS_NETCDF} -ljasper
+LDFLAGS = -L${GRIBAPI}/lib -lgrib_api_f90 -lgrib_api ${LDFLAGS_NETCDF} -ljasper -L${FLEXPART_SRC}
 
 
@@ -51,4 +55,11 @@
 ${BINARY}.o : ${BINARY}.F90 fp2nc4io_mod.mod ${FPMODOBJS} Makefile
 	${FC} -c ${BINARY}.F90 ${FFLAGS} ${INCLUDES}
+
+#-----------  NC4 compare ------------------------
+${CMP_BINARY} : ${CMP_BINARY}.o
+	${FC} -o ${CMP_BINARY} ${CMP_BINARY}.o ${LDFLAGS}
+
+${CMP_BINARY}.o : ${CMP_BINARY}.F90 Makefile
+	${FC} -c ${CMP_BINARY}.F90 ${FFLAGS} ${INCLUDES}
 
 fp2nc4io_mod.mod : ${FPMODOBJS} 
